/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version: 1.3.21
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.osgeo.mapguide;



/**
 * {@link MgEnvelope} represents a bounding box defined in terms of a
 * lower left coordinate and an upper right coordinate.
 *
 */
 public class MgEnvelope extends MgSerializable {
  private long swigCPtr;

  public MgEnvelope(long cPtr, boolean cMemoryOwn) {
    super(MapGuideDesktopApiJNI.SWIGMgEnvelopeToMgSerializable(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected void finalize() {
    delete();
  }

  public void delete() {
    if(swigCPtr != 0 && swigCMemOwn) {
      swigCMemOwn = false;
      MapGuideDesktopApiJNI.delete_MgEnvelope(swigCPtr);
    }
    swigCPtr = 0;
    super.delete();
  }

  protected static long getCPtr(MgEnvelope obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  
/**
 * Constructs and initializes  an "null" envelope.
 *
 */
 public MgEnvelope() {
    this(MapGuideDesktopApiJNI.new_MgEnvelope__SWIG_0(), true);
  }

  
/**
 * Constructs and initializes  an envelope for a region defined by one
 * coordinate.
 *
 * @param  coord ({@link MgCoordinate})  The {@link MgCoordinate} to use in defining the region.
 */
 public MgEnvelope(MgCoordinate coord) {
    this(MapGuideDesktopApiJNI.new_MgEnvelope__SWIG_1(MgCoordinate.getCPtr(coord)), true);
  }

  
/**
 * Constructs and initializes  an envelope for a region defined by two
 * coordinates.
 *
 * @param  coord1 ({@link MgCoordinate})  The first {@link MgCoordinate} to use in defining the region.
 * @param  coord2 ({@link MgCoordinate})  The second {@link MgCoordinate} to use in defining the region.
 */
 public MgEnvelope(MgCoordinate coord1, MgCoordinate coord2) {
    this(MapGuideDesktopApiJNI.new_MgEnvelope__SWIG_2(MgCoordinate.getCPtr(coord1), MgCoordinate.getCPtr(coord2)), true);
  }

  
/**
 * Constructs and initializes  an envelope for a region defined by two
 * coordinates , given as four doubles
 *
 * @param  xMin (double)  Left coordinate
 * @param  yMin (double)  Bottom coordinate
 * @param  xMax (double)  Right coordinate
 * @param  yMax (double)  Top coordinate
 */
 public MgEnvelope(double xMin, double yMin, double xMax, double yMax) {
    this(MapGuideDesktopApiJNI.new_MgEnvelope__SWIG_3(xMin, yMin, xMax, yMax), true);
  }

  
/**
 * Constructs and initializes  an envelope that is a copy of another.
 *
 * @param  envelope ({@link MgEnvelope})  The {@link MgEnvelope} to copy.
 */
 public MgEnvelope(MgEnvelope envelope) {
    this(MapGuideDesktopApiJNI.new_MgEnvelope__SWIG_4(MgEnvelope.getCPtr(envelope)), true);
  }

  
/**
 * Returns the lower left coordinate of the envelope.
 *
 * @return  An {@link MgCoordinate} that defines the lower left corner of the envelope.
 */
 public MgCoordinate getLowerLeftCoordinate() {
    long cPtr = MapGuideDesktopApiJNI.MgEnvelope_GetLowerLeftCoordinate(swigCPtr);
    return (cPtr == 0) ? null : (MgCoordinate)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Returns the upper right coordinate of the envelope.
 *
 * @return  An {@link MgCoordinate} that defines the upper right corner of the envelope.
 */
 public MgCoordinate getUpperRightCoordinate() {
    long cPtr = MapGuideDesktopApiJNI.MgEnvelope_GetUpperRightCoordinate(swigCPtr);
    return (cPtr == 0) ? null : (MgCoordinate)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Returns the difference between the maximum and minimum X values.
 *
 * @return  A double representing the width of the envelope.
 */
 public double getWidth() {
    return MapGuideDesktopApiJNI.MgEnvelope_GetWidth(swigCPtr);
  }

  
/**
 * Returns the difference between the maximum and minimum Y values.
 *
 * @return  A double representing the height of the envelope.
 */
 public double getHeight() {
    return MapGuideDesktopApiJNI.MgEnvelope_GetHeight(swigCPtr);
  }

  
/**
 * Returns the difference between the maximum and minimum Z values.
 *
 * @return  A double representing the depth of the envelope.
 */
 public double getDepth() {
    return MapGuideDesktopApiJNI.MgEnvelope_GetDepth(swigCPtr);
  }

  
/**
 * Tests whether this Envelope is "null" or not.
 *
 * @return  True if this envelope is "null", false otherwise.
 */
 public boolean isNull() {
    return MapGuideDesktopApiJNI.MgEnvelope_IsNull(swigCPtr);
  }

  
/**
 * Makes this envelope a "null" envelope.
 *
 */
 public void makeNull() {
    MapGuideDesktopApiJNI.MgEnvelope_MakeNull(swigCPtr);
  }

  
/**
 * Enlarges the boundary of the envelope so that it contains the given
 * coordinate.
 *
 * @param  coordinate ({@link MgCoordinate})  The {@link MgCoordinate} to expand this envelope to include.
 */
 public void expandToInclude(MgCoordinate coordinate) {
    MapGuideDesktopApiJNI.MgEnvelope_ExpandToInclude__SWIG_0(swigCPtr, MgCoordinate.getCPtr(coordinate));
  }

  
/**
 * Enlarges the boundary of the envelope so that it contains the given
 * envelope.
 *
 * @param  envelope ({@link MgEnvelope})  The {@link MgEnvelope} to expand this envelope to include.
 */
 public void expandToInclude(MgEnvelope envelope) {
    MapGuideDesktopApiJNI.MgEnvelope_ExpandToInclude__SWIG_1(swigCPtr, MgEnvelope.getCPtr(envelope));
  }

  
/**
 * Tests whether the given coordinate lies in or on this envelope.
 *
 * @param  coordinate ({@link MgCoordinate})  The {@link MgCoordinate} to test containment of.
 * @return  True if the coordinate is contained in this envelope, false otherwise.
 */
 public boolean contains(MgCoordinate coordinate) {
    return MapGuideDesktopApiJNI.MgEnvelope_Contains__SWIG_0(swigCPtr, MgCoordinate.getCPtr(coordinate));
  }

  
/**
 * Tests whether the given envelope lies completely inside this
 * Envelope (inclusive of the boundary).
 *
 * @param  envelope ({@link MgEnvelope})  The {@link MgEnvelope} to test containment of.
 * @return  True if the envelope argument is contained in this envelope,
 *  false otherwise.
 */
 public boolean contains(MgEnvelope envelope) {
    return MapGuideDesktopApiJNI.MgEnvelope_Contains__SWIG_1(swigCPtr, MgEnvelope.getCPtr(envelope));
  }

  
/**
 * Tests if the region defined by another envelope overlaps (intersects)
 * the region of this envelope.
 *
 * @param  envelope ({@link MgEnvelope})  The {@link MgEnvelope} to test for intersection.
 * @return  True if the envelopes intersect, false otherwise.
 */
 public boolean intersects(MgEnvelope envelope) {
    return MapGuideDesktopApiJNI.MgEnvelope_Intersects(swigCPtr, MgEnvelope.getCPtr(envelope));
  }

  
/**
 * Returns a transformed copy of this envelope.
 *
 * @param  transform ({@link MgTransform})  The {@link MgTransform} to use in constructing a copy of this envelope.
 * @return  An {@link MgEnvelope} that is a copy of this one but whose region is
 *  transformed.
 */
 public MgEnvelope transform(MgTransform transform) {
    long cPtr = MapGuideDesktopApiJNI.MgEnvelope_Transform(swigCPtr, MgTransform.getCPtr(transform));
    return (cPtr == 0) ? null : (MgEnvelope)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

}
